<!DOCTYPE html>
<html lang="de-DE">
{{> head }}

<body>
    <div>
        {{> nav }}
        <div>
            {{> breadcrumbs }}
            <div id="ovk-content" aria-label="Inhaltsbereich" role="main">
                {{> headline head="Schlüssel" }}
                <p>
                    Schlüssel dienen in einer relationalen Datenbank dazu, die Datensätze einer Tabelle eindeutig zu
                    identifizieren und zu referenzieren.
                </p>
                <h2>Primärschlüssel</h2>
                <p>{{> theorie }}
                    Das Attribut oder die Attributmenge, die für eine Tabelle diese eindeutige Referenz bereitstellt,
                    wird Primärschlüssel genannt. Kann eine solche Attributmenge nicht gefunden werden, so wird oftmals ein künstlicher
                    Schlüssel, beispielsweise ein Attribut „ID“ hinzugefügt, das über einen Integerwert jeden Datensatz
                    eindeutig identifiziert.
                </p>

                <h2>Fremdschlüssel</h2>
                <p>{{> theorie }}
                    Ein Fremdschlüssel ist ein Attribut oder eine Attributkombination einer Relation, welches auf den
                    Primärschlüssel einer anderen oder der gleichen Relation verweist. Damit wird eine Beziehung
                    zwischen den Tupeln der beteiligten Relationen dargestellt.
                </p>
                <h2>Primär- und Fremdschlüssel am Beispiel</h2>
                <p>
                    In ER-Diagrammen wurden die Primärschlüsselattribute unterstrichen dargestellt. Im Beispiel
                    ist das für die Tabellen <code>Lehrer</code>, <code>Klasse</code> und <code>Schueler</code> bereits
                    geschehen. Jede/r Lehrer:in hat eine eindeutige <code>PersonalNr</code>,
                    das Attribut <code>Klasse</code> speichert den Namen der Klasse, der für verschiedene Klassen
                    unterschiedlich ist. Jede/r Schüler:in hat eine eindeutige <code>SchuelerNr</code>.
                </p>
                <p>
                    Außerdem kann jede/r Schüler:in zu einem Zeitpunkt nur genau einer Klasse angehören. Demzufolge hat
                    die Tabelle <code>Schueler</code> eine Fremdschlüsselbeziehung zur Tabelle <code>Klasse</code>. Das
                    bedeutet, dass der Tabelle <code>Schueler</code> ein zusätzliches Attribut <code>Klasse</code>
                    hinzugefügt wurde, welches angibt, zu welcher Klasse der/die Schüler:in gehört.
                </p>

                <img width="80%" src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/ER-Modell.png"
                    alt="ER Modell" />
                <h2>Übung</h2>
                <iframe title="Grundkonzepte Datenbanken"
                    src="https://ddivideo.inf.tu-dresden.de/wp-admin/admin-ajax.php?action=h5p_embed&id=19" width="900"
                    height="500">
                </iframe>
            </div>
        </div>
</body>

</html>